/* */

if RxFuncQuery('SysLoadFuncs') then do
  call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
  call SysLoadFuncs
end

say "Warning! Read readme.txt before updating!"
Say "Do you want to continue? (Y/N)"
do until (pos(key,"YN") > 0) 
  key = translate(SysGetKey("NOECHO")) 
end 
if (key == "N") then exit;

parse source dir;
parse var dir x1 x2 dir;
dir = filespec("D", dir)||filespec("P", dir);
if (right(dir, 1) = "\") then dir = left(dir, length(dir)-1);

if (SysRegisterObjectClass("barTask", dir||"\mview.dll")) then Say "OK"; else Say "failed";
if (SysRegisterObjectClass("barTasks", dir||"\mview.dll")) then Say "OK"; else Say "failed";
if (SysRegisterObjectClass("barMonManual", dir||"\mview.dll")) then Say "OK"; else Say "failed";
if (SysRegisterObjectClass("barInfo", dir||"\mview.dll")) then Say "OK"; else Say "failed";

if (SysCreateObject("TrayHolder", "Tray holder (new objects)", "<WP_DESKTOP>","OBJECTID=<bar_TrayNew>;ICONVIEW=NONFLOWED,MINI;ELEMENT_SIZE=180;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("TrayViewer", "Qu2/Z! Stat", "<bar_TrayNew>","OBJECTID=<bar_Tray2_1>;ICONVIEW=NONFLOWED,MINI;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("barInfo", "Qu2/Z! Stat", "<bar_Tray2_1>","OBJECTID=<BAR_INFOZ>;ICONVIEW=NONFLOWED,MINI;ELEMENT_SIZE=160")) then Say "OK"; else Say "failed";
if (SysCreateObject("TrayViewer", "Qu2 control center (req 0.99c-pre3)", "<bar_TrayNew>","OBJECTID=<bar_Tray2_2>;ICONVIEW=NONFLOWED,MINI;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("ObjectsBar", "Objects bar", "<bar_Tray2_2>","OBJECTID=<bar_ObjBar2_1>;ICONVIEW=NONFLOWED,MINI;ELEMENT_SIZE=160;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Qu2 VIO", "<bar_ObjBar2_1>","EXENAME=QUVIO.EXE;PROGTYPE=WINDOWABLEVIO")) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Start Qu2 status", "<bar_ObjBar2_1>","EXENAME=cmd.exe;PROGTYPE=WINDOWABLEVIO;PARAMETERS=/c detach "dir"\scripts\Qu2Stat.cmd;STARTUPDIR="dir)) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Pause", "<bar_ObjBar2_1>","EXENAME="dir"\scripts\PAUSE.CMD;ICONFILE="dir"\Icons\PAUSE.ico;PROGTYPE=WINDOWABLEVIO;STARTUPDIR="dir)) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Unpause", "<bar_ObjBar2_1>","EXENAME="dir"\scripts\UNPAUSE.CMD;ICONFILE="dir"\Icons\UNPAUSE.ico;PROGTYPE=WINDOWABLEVIO;STARTUPDIR="dir)) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Next", "<bar_ObjBar2_1>","EXENAME="dir"\scripts\NEXT.CMD;ICONFILE="dir"\Icons\NEXT.ico;PROGTYPE=WINDOWABLEVIO;STARTUPDIR="dir)) then Say "OK"; else Say "failed";

if (SysCreateObject("TrayViewer", "Z! control center", "<bar_TrayNew>","OBJECTID=<bar_Tray2_3>;ICONVIEW=NONFLOWED,MINI;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("ObjectsBar", "Objects bar", "<bar_Tray2_3>","OBJECTID=<bar_ObjBar3_1>;ICONVIEW=NONFLOWED,MINI;ELEMENT_SIZE=160;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Z!", "<bar_ObjBar3_1>","EXENAME=Z.EXE;PROGTYPE=WINDOWABLEVIO")) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Start Z! status", "<bar_ObjBar3_1>","EXENAME=cmd.exe;PROGTYPE=WINDOWABLEVIO;PARAMETERS=/c detach "dir"\scripts\Z!2Stat.cmd;STARTUPDIR="dir)) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Pause", "<bar_ObjBar3_1>","EXENAME="dir"\scripts\PAUSE_Z.CMD;ICONFILE="dir"\Icons\PAUSE.ico;PROGTYPE=WINDOWABLEVIO;STARTUPDIR="dir)) then Say "OK"; else Say "failed";
if (SysCreateObject("WPProgram", "Next", "<bar_ObjBar3_1>","EXENAME="dir"\scripts\NEXT_Z.CMD;ICONFILE="dir"\Icons\NEXT.ico;PROGTYPE=WINDOWABLEVIO;STARTUPDIR="dir)) then Say "OK"; else Say "failed";

Say "Do you want to recreate templates (recommended)? (Y/N)"
do until (pos(key,"YN") > 0) 
  key = translate(SysGetKey("NOECHO")) 
end 
if (key == "Y") then do
  say "Deleting old temlates:"
  if \ SysDestroyObject("<WPSBar_Templ>") then do
    say "Could not destroy templates folder. Continue anyway? (Y/N)"
    do until (pos(key,"YN") > 0) 
      key = translate(SysGetKey("NOECHO")) 
    end 
    if (key == "N") then do
      say 'Put new holder into WPSBar'
      exit
    end
  end
  else say "OK"
say "Creating temlates:"
if (SysCreateObject("WPFolder", "WPSBar templates", "<WP_DESKTOP>","OBJECTID=<WPSBar_Templ>")) then Say "OK"; else Say "failed";
if (SysCreateObject("ObjectsBar", "Objects bar", "<WPSBar_Templ>","TEMPLATE=YES;ICONVIEW=NONFLOWED,MINI;ELEMENT_SIZE=60;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("Lockup", "Lockup system", "<WPSBar_Templ>", "TEMPLATE=YES")) then Say "OK"; else Say "failed";
if (SysCreateObject("BarSwitch", "Task switcher", "<WPSBar_Templ>","TEMPLATE=YES;ELEMENT_SIZE=30")) then Say "OK"; else Say "failed";
if (SysCreateObject("BarMonDisk", "Disk free space monitor (C:)", "<WPSBar_Templ>","TEMPLATE=YES;ELEMENT_SIZE=100")) then Say "OK"; else Say "failed";
if (SysCreateObject("BarMonCPU", "CPU load monitor", "<WPSBar_Templ>","TEMPLATE=YES;ELEMENT_SIZE=100")) then Say "OK"; else Say "failed";
if (SysCreateObject("TrayHolder", "Tray holder (place trays here)", "<WPSBar_Templ>","TEMPLATE=YES;ICONVIEW=NONFLOWED,MINI;ELEMENT_SIZE=300;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("TrayViewer", "Tray", "<WPSBar_Templ>","TEMPLATE=YES;ICONVIEW=NONFLOWED,MINI;DEFAULTVIEW=ICON")) then Say "OK"; else Say "failed";
if (SysCreateObject("BarClock", "Clock", "<WPSBar_Templ>", "TEMPLATE=YES")) then Say "OK"; else Say "failed";
end

say 'Put new holder into WPSBar'
